library auth_test;

import 'dart:convert';
import 'dart:ui';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:webview_flutter_plus/webview_flutter_plus.dart';
import 'package:flutter_secure_storage/flutter_secure_storage.dart';
import 'package:http/http.dart' as http;

class demoAuth extends StatefulWidget {
  const demoAuth({Key? key, required this.keyId, required this.secretId}) : super(key: key);
  final String keyId, secretId;

  @override
  _demoAuthState createState() => _demoAuthState();
}

class _demoAuthState extends State<demoAuth> {

  late WebViewPlusController controller;
  final storage = new FlutterSecureStorage();


  @override
  Widget build(BuildContext context) => WillPopScope(
      onWillPop: () async{
        return true;
      },
      child:Scaffold(
        body: WebViewPlus(
          javascriptMode: JavascriptMode.unrestricted,
          initialUrl: 'https://api.secuuth.io/auth/getLoginWebview/?keyId=${widget.keyId}&profileName=Default&clientType=Flutter&secretKey=${widget.secretId}',
          // initialUrl: 'https://test-api.secuuth.io/auth/getLoginWebview/?keyId=63576492-4af2-4363-919b-1b47b80b1bcb&profileName=Default&clientType=Flutter&secretKey=TlD3JgkSt70Iq5uv',
          // initialUrl:'https://api.secuuth.io/auth/getLoginWebview/?keyId=63576492-4af2-4363-919b-1b47b80b1bcb&profileName=Default&clientType=Flutter&secretKey=TlD3JgkSt70Iq5uv',
          onWebViewCreated: (controller){
            this.controller = controller;
            // controller.webViewController.clearCache();
            // final cookieManager = CookieManager();
            // cookieManager.clearCookies();
          },
          javascriptChannels: {
            JavascriptChannel(
                name: 'JavascriptChannel',
                onMessageReceived: (payload) async {
                  print('Javascript: "${payload.message}" ');
                  // await storage.deleteAll();
                  await storage.write(key: 'SecqureRefreshToken', value: payload.message);
                  await storage.write(key: 'SecqureUserPubKey', value: payload.message);
                  await storage.write(key: 'SecqureUserId', value: payload.message);

                  String? refreshToken = await storage.read(key: 'SecqureRefreshToken');
                  String? pubKey = await storage.read(key: 'SecqureUserPubKey');
                  String? userId = await storage.read(key: 'SecqureUserId');

                  if (refreshToken != null && pubKey != null && userId != null) {
                    try{
                      final uri = Uri.parse('https://api.secuuth.io/auth/renewTokens');
                      Map<String, String> headers = {"Accept": 'application/json', "keyId": widget.keyId};
                      Map<dynamic, dynamic> JsonBody = {
                        "refreshToken": refreshToken,
                        "publicKey": pubKey,
                        "userSubId": userId,
                        "renewRefreshToken": false,
                      };

                      http.Response tokens = await http.post(uri, headers: headers, body: JsonBody);
                      String res = tokens.toString();
                    }
                    catch (e) {
                      throw Exception(e);
                    }
                  }
                }
            )
          },
        ),
      )
  );
}

